; ----------------------------------------------------------------
;- Date Test using DayCount4.pbi (horst.schaeffer@gmx.net)
; ----------------------------------------------------------------
#title = "Date Test " : #version =  "ver. 1.5"  ; PB 4.5x - 04 May 2011 
XIncludeFile "DayCount4.pbi"  

#testFormat = "ddd, MMM dd, yyyy;yyyy-MM-dd;dd. MMMM yyyy (dddd);yyyyMMdd" ; 4 + local long date
; ---------------------------------------------------------------
;  Window 
; ---------------------------------------------------------------
Enumeration 1 : #formatCombo : #format1 : #format2 : #diffText : EndEnumeration
Font = LoadFont(0,"MS Shell DLG 2",9)
#width = 450 : #height = 130

WinHandle = OpenWindow(0,0,0,#width,#height,#title,#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
If WinHandle = 0 : End : EndIf 
SetGadgetFont(#PB_Default,Font)

; Date input ---------------------------------------

TextGadget(#PB_Any,10,50,60,22,"Date(1)",#PB_Text_Right)
Date1handle = DateInputGadget(80,45,120,24,WinHandle) 
  SendMessage_(Date1handle,#WM_SETFONT,Font,1) 

TextGadget(#PB_Any,10,75,60,22,"Date(2)",#PB_Text_Right)
Date2handle = DateInputGadget(80,70,120,24,WinHandle)
  SendMessage_(Date2handle,#WM_SETFONT,Font,1) 

  ; Format selection ---------------------------------
  
TextGadget(#PB_Any,140,15,60,22,"Format",#PB_Text_Right)
ComboBoxGadget(#formatCombo,220,10,180,22)
  For i = 0 To 4
    If i = 0 : form$ = GetDateFormat(#longdate)       ; local long date
    Else :     form$ = StringField(#testFormat,i,";") ; test formats
    EndIf 
    AddGadgetItem(#formatCombo,i,form$)
  Next   
  SetGadgetState(#formatCombo,0)

  ; Output -------------------------------------------
  
TextGadget(#format1,220,50,#width-220,22,"")
TextGadget(#format2,220,75,#width-220,22,"")
TextGadget(#diffText,220,100,#width-220,22,"")

; ---------------------------------------------------------------
;  Date Operations 
; ---------------------------------------------------------------

Procedure UpdateOutput()
  Shared Date1count, Date2count 
  Shared Date1handle, Date2handle 
  format$ = GetGadgetText(#formatCombo)
  
  Date1count = GetInputDate(Date1handle)
  SetGadgetText(#format1,GetDateString(format$,Date1count))

  Date2count = GetInputDate(Date2handle)
  SetGadgetText(#format2,GetDateString(format$,Date2count))

  SetGadgetText(#diffText,"Difference: "+ Str(Date2count-Date1count) + " Days")
EndProcedure 

; ---------------------------------------------------------------
;-  Main 
; ---------------------------------------------------------------
  ; initial dates
  Today(Date1count,@TD.SYSTEMTIME) 
  SetInputDate(Date1handle,Date1count) 
  Date2count = Date1count
  SetInputDate(Date2handle,Date2count) 
  UpdateOutput()  
  
  Repeat 
    event = WaitWindowEvent()

    If event = #PB_Event_Gadget 
      If EventGadget() = #formatCombo And EventType() = #CBN_SELCHANGE
        UpdateOutput() 
      EndIf 
    ElseIf event = #DateInputEvent : UpdateOutput() : EndIf 
    
  Until event = #PB_Event_CloseWindow
  CloseWindow(0)
End
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableXP
; Executable = DateTest.exe
; CompileSourceDirectory